<?php
/*
0. Проверяем версию и наличие бэкапа 24-часовой давности
1. Дописываем новые строки к config.ini
2. Заменяем adminer.php
3. Удаляем старое ядро
4. Копируем обновленное ядро, чистим modules от себя
5. Создаем таблицу news
6. Переносим категории из news_categories в news
7. Переносим новости из news_items в news
*/

function copyRecursive($src, $dst) {
    if (!file_exists($dst)) mkdir($dst);
    $files = scandir($src);
    foreach ($files as $file) if ($file != '.' && $file != '..') {
        if (is_dir($src.'/'.$file)) copyRecursive($src.'/'.$file, $dst.'/'.$file);
        else copy($src.'/'.$file, $dst.'/'.$file);
    }
}

function clearRecursive($dir) {
    $files = scandir($dir);
    foreach ($files as $file) if ($file != '.' && $file != '..') {
        if (is_dir($dir.'/'.$file)) {
            clearRecursive($dir.'/'.$file);
            rmdir($dir.'/'.$file);
        } else {
            unlink($dir.'/'.$file);
        }
    }
}

#0
if (USER_CMS_VERSION !== 2.3) {
    $this->data['errors'][] = 'Это модуль обновления для UserCMS версии 2.3. У вас установлена версия '.USER_CMS_VERSION.'.';
    return false;
}
$haveBackup = false;
if (is_dir(ROOT_DIR.'/temp/backups')) {
    $backups = scandir(ROOT_DIR.'/temp/backups');
    foreach($backups as $backup)
    if (pathinfo(ROOT_DIR.'/temp/backups/'.$backup, PATHINFO_EXTENSION) == 'zip' &&
        time() - filectime(ROOT_DIR.'/temp/backups/'.$backup) < 24*3600)
    {
        $haveBackup = true;
        break;
    }
}
if (!$haveBackup) {
    $this->data['errors'][] = 'Прежде чем устанавливать обновление сделайте полный бэкап системы.';
    return false;
}

#1
file_put_contents(ROOT_DIR.'/config.ini',
'
maintenance="0"
site_email="admin@thissite.com"
site_email2="info@thissite.com"
site_phone="+7 (900) 123-45-67"
site_phone_f="+79001234567"',
FILE_APPEND);

#2
rename(ROOT_DIR.'/modules/upd/adminer.php', ROOT_DIR.'/adminer.php');

#3
clearRecursive(ROOT_DIR.'/user_cms');

#4
copyRecursive(ROOT_DIR.'/modules/upd/user_cms', ROOT_DIR.'/user_cms');
clearRecursive(ROOT_DIR.'/modules/upd');
rmdir(ROOT_DIR.'/modules/upd');

#5
$table_news_created = $this->dbh->exec("CREATE TABLE news (
    id INTEGER PRIMARY KEY AUTOINCREMENT,
    url TEXT,
    header TEXT,
    overview TEXT,
    photo TEXT,
    text TEXT,
    title TEXT,
    keywords TEXT,
    description TEXT,
    date_create INTEGER,
    date_edit INTEGER,
    date_publish INTEGER,
    parent_id INTEGER,
    is_category INTEGER
)");
if (!$table_news_created) {
    $this->data['errors'][] = 'Не удалось создать таблицу news.';
    return false;
}

#6
$categories = $this->dbh->query("SELECT * FROM news_categories");
foreach ($categories as $category) {
    if (!isset($category['sub'])) $category['sub'] = 0;
    $this->dbh->exec("INSERT INTO news
        (
            id,
            url,
            header,
            overview,
            photo,
            text,
            title,
            keywords,
            description,
            date_create,
            date_edit,
            date_publish,
            parent_id,
            is_category
        )
        VALUES
        (
            '$category[id]',
            '$category[url]',
            '$category[name]',
            '$category[preview]',
            '',
            '$category[text]',
            '$category[title]',
            '$category[keywords]',
            '$category[description]',
            '$category[date_add]',
            '$category[date_edit]',
            '".time()."',
            '$category[sub]',
            '1'
        )
    ");
}
$this->dbh->query("DROP TABLE news_categories");

#7
$items = $this->dbh->query("SELECT * FROM news_items");
foreach ($items as $item) {
    $this->dbh->exec("INSERT INTO news
        (
            url,
            header,
            overview,
            photo,
            text,
            title,
            keywords,
            description,
            date_create,
            date_edit,
            date_publish,
            parent_id,
            is_category
        )
        VALUES
        (
            '$item[url]',
            '$item[name]',
            '$item[preview]',
            '',
            '$item[text]',
            '$item[title]',
            '$item[keywords]',
            '$item[description]',
            '$item[date_add]',
            '$item[date_edit]',
            '".time()."',
            '$item[category_id]',
            '0'
        )
    ");
}
$this->dbh->query("DROP TABLE news_items");

$this->data['message'] = 'Система успешно обновлена.';
return true;